package net.mcreator.underground_expansion;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.common.util.EnumHelper;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.client.event.ModelRegistryEvent;

import net.minecraft.item.ItemArmor;
import net.minecraft.item.Item;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;

public class MCreatorSapphireArmor extends underground_expansion.ModElement {

	@GameRegistry.ObjectHolder("underground_expansion:sapphirearmorhelmet")
	public static final Item helmet = null;
	@GameRegistry.ObjectHolder("underground_expansion:sapphirearmorbody")
	public static final Item body = null;
	@GameRegistry.ObjectHolder("underground_expansion:sapphirearmorlegs")
	public static final Item legs = null;
	@GameRegistry.ObjectHolder("underground_expansion:sapphirearmorboots")
	public static final Item boots = null;

	public MCreatorSapphireArmor(underground_expansion instance) {
		super(instance);
		ItemArmor.ArmorMaterial enuma = EnumHelper.addArmorMaterial("SAPPHIREARMOR", "underground_expansion:sapphirearmor", 35,
				new int[]{9, 9, 9, 9}, 50, null, 3f);
		instance.items.add(() -> new ItemArmor(enuma, 0, EntityEquipmentSlot.HEAD).setUnlocalizedName("sapphirearmorhelmet")
				.setRegistryName("sapphirearmorhelmet").setCreativeTab(CreativeTabs.COMBAT));
		instance.items.add(() -> new ItemArmor(enuma, 0, EntityEquipmentSlot.CHEST).setUnlocalizedName("sapphirearmorbody")
				.setRegistryName("sapphirearmorbody").setCreativeTab(CreativeTabs.COMBAT));
		instance.items.add(() -> new ItemArmor(enuma, 0, EntityEquipmentSlot.LEGS).setUnlocalizedName("sapphirearmorlegs")
				.setRegistryName("sapphirearmorlegs").setCreativeTab(CreativeTabs.COMBAT));
		instance.items.add(() -> new ItemArmor(enuma, 0, EntityEquipmentSlot.FEET).setUnlocalizedName("sapphirearmorboots")
				.setRegistryName("sapphirearmorboots").setCreativeTab(CreativeTabs.COMBAT));
	}

	@SideOnly(Side.CLIENT)
	@Override
	public void registerModels(ModelRegistryEvent event) {
		ModelLoader.setCustomModelResourceLocation(helmet, 0, new ModelResourceLocation("underground_expansion:sapphirearmorhelmet", "inventory"));
		ModelLoader.setCustomModelResourceLocation(body, 0, new ModelResourceLocation("underground_expansion:sapphirearmorbody", "inventory"));
		ModelLoader.setCustomModelResourceLocation(legs, 0, new ModelResourceLocation("underground_expansion:sapphirearmorlegs", "inventory"));
		ModelLoader.setCustomModelResourceLocation(boots, 0, new ModelResourceLocation("underground_expansion:sapphirearmorboots", "inventory"));
	}
}
