package net.mcreator.underground_expansion;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.common.util.EnumHelper;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.client.event.ModelRegistryEvent;

import net.minecraft.item.ItemArmor;
import net.minecraft.item.Item;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;

public class MCreatorTopazArmor extends underground_expansion.ModElement {

	@GameRegistry.ObjectHolder("underground_expansion:topazarmorhelmet")
	public static final Item helmet = null;
	@GameRegistry.ObjectHolder("underground_expansion:topazarmorbody")
	public static final Item body = null;
	@GameRegistry.ObjectHolder("underground_expansion:topazarmorlegs")
	public static final Item legs = null;
	@GameRegistry.ObjectHolder("underground_expansion:topazarmorboots")
	public static final Item boots = null;

	public MCreatorTopazArmor(underground_expansion instance) {
		super(instance);
		ItemArmor.ArmorMaterial enuma = EnumHelper.addArmorMaterial("TOPAZARMOR", "underground_expansion:topazarmor", 30, new int[]{8, 8, 8, 8}, 40,
				null, 2.5f);
		instance.items.add(() -> new ItemArmor(enuma, 0, EntityEquipmentSlot.HEAD).setUnlocalizedName("topazarmorhelmet")
				.setRegistryName("topazarmorhelmet").setCreativeTab(CreativeTabs.COMBAT));
		instance.items.add(() -> new ItemArmor(enuma, 0, EntityEquipmentSlot.CHEST).setUnlocalizedName("topazarmorbody")
				.setRegistryName("topazarmorbody").setCreativeTab(CreativeTabs.COMBAT));
		instance.items.add(() -> new ItemArmor(enuma, 0, EntityEquipmentSlot.LEGS).setUnlocalizedName("topazarmorlegs")
				.setRegistryName("topazarmorlegs").setCreativeTab(CreativeTabs.COMBAT));
		instance.items.add(() -> new ItemArmor(enuma, 0, EntityEquipmentSlot.FEET).setUnlocalizedName("topazarmorboots")
				.setRegistryName("topazarmorboots").setCreativeTab(CreativeTabs.COMBAT));
	}

	@SideOnly(Side.CLIENT)
	@Override
	public void registerModels(ModelRegistryEvent event) {
		ModelLoader.setCustomModelResourceLocation(helmet, 0, new ModelResourceLocation("underground_expansion:topazarmorhelmet", "inventory"));
		ModelLoader.setCustomModelResourceLocation(body, 0, new ModelResourceLocation("underground_expansion:topazarmorbody", "inventory"));
		ModelLoader.setCustomModelResourceLocation(legs, 0, new ModelResourceLocation("underground_expansion:topazarmorlegs", "inventory"));
		ModelLoader.setCustomModelResourceLocation(boots, 0, new ModelResourceLocation("underground_expansion:topazarmorboots", "inventory"));
	}
}
