package net.mcreator.underground_expansion;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.common.registry.EntityEntry;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.network.IGuiHandler;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.SidedProxy;
import net.minecraftforge.fml.common.Mod.Instance;
import net.minecraftforge.fml.common.Mod.EventHandler;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.IWorldGenerator;
import net.minecraftforge.fml.common.IFuelHandler;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.client.event.ModelRegistryEvent;

import net.minecraft.world.gen.IChunkGenerator;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.potion.Potion;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.block.Block;

import java.util.function.Supplier;
import java.util.Random;
import java.util.List;
import java.util.ArrayList;

@Mod(modid = underground_expansion.MODID, version = underground_expansion.VERSION)
public class underground_expansion implements IFuelHandler, IWorldGenerator {

	public static final String MODID = "underground_expansion";
	public static final String VERSION = "1.0.0";
	@SidedProxy(clientSide = "net.mcreator.underground_expansion.ClientProxyunderground_expansion", serverSide = "net.mcreator.underground_expansion.CommonProxyunderground_expansion")
	public static CommonProxyunderground_expansion proxy;
	@Instance(MODID)
	public static underground_expansion instance;
	public final List<ModElement> elements = new ArrayList<>();
	public final List<Supplier<Block>> blocks = new ArrayList<>();
	public final List<Supplier<Item>> items = new ArrayList<>();
	public final List<Supplier<Biome>> biomes = new ArrayList<>();
	public final List<Supplier<EntityEntry>> entities = new ArrayList<>();
	public final List<Supplier<Potion>> potions = new ArrayList<>();

	public underground_expansion() {
		FluidRegistry.enableUniversalBucket();
		elements.add(new MCreatorRedCap(this));
		elements.add(new MCreatorRedCapFood(this));
		elements.add(new MCreatorOrangeCap(this));
		elements.add(new MCreatorOrangeCapFood(this));
		elements.add(new MCreatorYellowCap(this));
		elements.add(new MCreatorYellowCapFood(this));
		elements.add(new MCreatorGreenCap(this));
		elements.add(new MCreatorGreenCapFood(this));
		elements.add(new MCreatorBlueCap(this));
		elements.add(new MCreatorBlueCapFood(this));
		elements.add(new MCreatorPurpleCap(this));
		elements.add(new MCreatorPurpleCapFood(this));
		elements.add(new MCreatorRuby(this));
		elements.add(new MCreatorRubyOre(this));
		elements.add(new MCreatorRubyBlock(this));
		elements.add(new MCreatorTopaz(this));
		elements.add(new MCreatorTopazOre(this));
		elements.add(new MCreatorTopazBlock(this));
		elements.add(new MCreatorSapphire(this));
		elements.add(new MCreatorSapphireOre(this));
		elements.add(new MCreatorSapphireBlock(this));
		elements.add(new MCreatorAmethyst(this));
		elements.add(new MCreatorAmethystOre(this));
		elements.add(new MCreatorAmethystBlock(this));
		elements.add(new MCreatorRubySword(this));
		elements.add(new MCreatorRubyPickaxe(this));
		elements.add(new MCreatorRubyAxe(this));
		elements.add(new MCreatorRubyShovel(this));
		elements.add(new MCreatorRubySwordRecipe(this));
		elements.add(new MCreatorRubyPickaxeRecipe(this));
		elements.add(new MCreatorRubyAxeRecipe(this));
		elements.add(new MCreatorRubyShovelRecipe(this));
		elements.add(new MCreatorRubyArmor(this));
		elements.add(new MCreatorAsphaltCobblestone(this));
		elements.add(new MCreatorAsphaltStone(this));
		elements.add(new MCreatorAsphaltFurnaceRecipe(this));
		elements.add(new MCreatorRubyHelmetRecipe(this));
		elements.add(new MCreatorRubyChestplateRecipe(this));
		elements.add(new MCreatorRubyLeggingsRecipe(this));
		elements.add(new MCreatorRubyBootsRecipe(this));
		elements.add(new MCreatorMarbleCobblestone(this));
		elements.add(new MCreatorMarbleStone(this));
		elements.add(new MCreatorLimestone(this));
		elements.add(new MCreatorSmoothLimestone(this));
		elements.add(new MCreatorColdCobblestone(this));
		elements.add(new MCreatorColdstone(this));
		elements.add(new MCreatorCanyonCobblestone(this));
		elements.add(new MCreatorCanyonStone(this));
		elements.add(new MCreatorAmethystSword(this));
		elements.add(new MCreatorAmethystPickaxe(this));
		elements.add(new MCreatorAmethystAxe(this));
		elements.add(new MCreatorAmethystShovel(this));
		elements.add(new MCreatorAmethystSwordRecipe(this));
		elements.add(new MCreatorAmethystPickaxeRecipe(this));
		elements.add(new MCreatorAmethystAxeRecipe(this));
		elements.add(new MCreatorAmethystShovelRecipe(this));
		elements.add(new MCreatorAmethystArmor(this));
		elements.add(new MCreatorAmethystHelmetRecipe(this));
		elements.add(new MCreatorAmethystChestplate(this));
		elements.add(new MCreatorAmethystLeggingsRecipe(this));
		elements.add(new MCreatorAmethystBootsRecipe(this));
		elements.add(new MCreatorFusionGem(this));
		elements.add(new MCreatorFusionOre(this));
		elements.add(new MCreatorStormIngot(this));
		elements.add(new MCreatorStormIngotRecipe(this));
		elements.add(new MCreatorBladeOfThunder(this));
		elements.add(new MCreatorPickaxeOfLightningSpeed(this));
		elements.add(new MCreatorAxeOfGreatPetrifying(this));
		elements.add(new MCreatorShovelOfTremendousFlooding(this));
		elements.add(new MCreatorBOTrecipe(this));
		elements.add(new MCreatorPOLSrecipe(this));
		elements.add(new MCreatorAOGPrecipe(this));
		elements.add(new MCreatorSOTFrecipe(this));
		elements.add(new MCreatorTheresMore(this));
		elements.add(new MCreatorTheresMoreProcedure(this));
		elements.add(new MCreatorSapphireSword(this));
		elements.add(new MCreatorSapphirePickaxe(this));
		elements.add(new MCreatorSapphireAxe(this));
		elements.add(new MCreatorSapphireShovel(this));
		elements.add(new MCreatorSapphireSwordRecipe(this));
		elements.add(new MCreatorSapphirePickaxeRecipe(this));
		elements.add(new MCreatorSapphireAxeRecipe(this));
		elements.add(new MCreatorSapphireShovelRecipe(this));
		elements.add(new MCreatorSapphireArmor(this));
		elements.add(new MCreatorSapphireHelmetRecipe(this));
		elements.add(new MCreatorSapphireChestplateRecipe(this));
		elements.add(new MCreatorSapphireLeggingsRecipe(this));
		elements.add(new MCreatorSapphireBootsRecipe(this));
		elements.add(new MCreatorTopazSword(this));
		elements.add(new MCreatorTopazPickaxe(this));
		elements.add(new MCreatorTopazAxe(this));
		elements.add(new MCreatorTopazShovel(this));
		elements.add(new MCreatorTopazSwordRecipe(this));
		elements.add(new MCreatorTopazPickaxeRecipe(this));
		elements.add(new MCreatorTopazAxeRecipe(this));
		elements.add(new MCreatorTopazShovelRecipe(this));
		elements.add(new MCreatorTopazArmor(this));
		elements.add(new MCreatorTopazHelmetRecipe(this));
		elements.add(new MCreatorTopazChestplateRecipe(this));
		elements.add(new MCreatorTopazLeggingsRecipe(this));
		elements.add(new MCreatorTopazBoots(this));
		elements.add(new MCreatorEmeraldSword(this));
		elements.add(new MCreatorEmeraldPickaxe(this));
		elements.add(new MCreatorEmeraldAxe(this));
		elements.add(new MCreatorEmeraldShovel(this));
		elements.add(new MCreatorEmeraldSwordRecipe(this));
		elements.add(new MCreatorEmeraldPickaxeRecipe(this));
		elements.add(new MCreatorEmeraldAxeRecipe(this));
		elements.add(new MCreatorEmeraldShovelRecipe(this));
		elements.add(new MCreatorEmeraldArmor(this));
		elements.add(new MCreatorEmeraldHelmetRecipe(this));
		elements.add(new MCreatorEmeraldChestplateRecipe(this));
		elements.add(new MCreatorEmeraldLeggingsRecipe(this));
		elements.add(new MCreatorEmeraldBootsRecipe(this));
		elements.add(new MCreatorLightningStrike(this));
		elements.add(new MCreatorAsphaltDiamondOre(this));
		elements.add(new MCreatorKolaniiteCobblestone(this));
		elements.add(new MCreatorKolaniiteStone(this));
		elements.add(new MCreatorRhyoliteCobblestone(this));
		elements.add(new MCreatorRhyoliteStone(this));
		elements.add(new MCreatorCopperIngot(this));
		elements.add(new MCreatorCopperOre(this));
		elements.add(new MCreatorCopperIngotRecipe(this));
		elements.add(new MCreatorAluminumIngot(this));
		elements.add(new MCreatorAluminumOre(this));
		elements.add(new MCreatorAluminumIngotRecipe(this));
		elements.add(new MCreatorLeadIngot(this));
		elements.add(new MCreatorLeadOre(this));
		elements.add(new MCreatorLeadIngotRecipe(this));
		elements.add(new MCreatorSteelIngot(this));
		elements.add(new MCreatorSteelingotRecipe(this));
		elements.add(new MCreatorAduriteIngot(this));
		elements.add(new MCreatorAduriteOre(this));
		elements.add(new MCreatorAduriteIngotRecipe(this));
		elements.add(new MCreatorCrystalChunk(this));
		elements.add(new MCreatorCrystalOre(this));
		elements.add(new MCreatorCobaltIngot(this));
		elements.add(new MCreatorCobaltOre(this));
		elements.add(new MCreatorCobaltIngotRecipe(this));
		elements.add(new MCreatorMagnetiteIngot(this));
		elements.add(new MCreatorMagnetiteOre(this));
		elements.add(new MCreatorMagnetiteIngotRecipe(this));
		elements.add(new MCreatorMalachiteIngot(this));
		elements.add(new MCreatorMalachiteOre(this));
		elements.add(new MCreatorMalachiteIngotRecipe(this));
		elements.add(new MCreatorSilverIngot(this));
		elements.add(new MCreatorSilverOre(this));
		elements.add(new MCreatorSilverIngotRecipe(this));
		elements.add(new MCreatorPlatinumIngot(this));
		elements.add(new MCreatorPlatinumOre(this));
		elements.add(new MCreatorPlatinumIngotRecipe(this));
		elements.add(new MCreatorTungstenIngot(this));
		elements.add(new MCreatorTungstenOre(this));
		elements.add(new MCreatorTungstenIngotRecipe(this));
		elements.add(new MCreatorTitaniumIngot(this));
		elements.add(new MCreatorTitaniumOre(this));
		elements.add(new MCreatorTitaniumIngotRecipe(this));
		elements.add(new MCreatorMagmaIngot(this));
		elements.add(new MCreatorMagmaIngotRecipe(this));
	}

	@Override
	public int getBurnTime(ItemStack fuel) {
		for (ModElement element : elements) {
			int ret = element.addFuel(fuel);
			if (ret != 0)
				return ret;
		}
		return 0;
	}

	@Override
	public void generate(Random random, int chunkX, int chunkZ, World world, IChunkGenerator cg, IChunkProvider cp) {
		elements.forEach(element -> element.generateWorld(random, chunkX * 16, chunkZ * 16, world, world.provider.getDimension(), cg, cp));
	}

	@SubscribeEvent
	public void registerBlocks(RegistryEvent.Register<Block> event) {
		event.getRegistry().registerAll(blocks.stream().map(Supplier::get).toArray(Block[]::new));
	}

	@SubscribeEvent
	public void registerItems(RegistryEvent.Register<Item> event) {
		event.getRegistry().registerAll(items.stream().map(Supplier::get).toArray(Item[]::new));
	}

	@SubscribeEvent
	public void registerBiomes(RegistryEvent.Register<Biome> event) {
		event.getRegistry().registerAll(biomes.stream().map(Supplier::get).toArray(Biome[]::new));
	}

	@SubscribeEvent
	public void registerEntities(RegistryEvent.Register<EntityEntry> event) {
		event.getRegistry().registerAll(entities.stream().map(Supplier::get).toArray(EntityEntry[]::new));
	}

	@SubscribeEvent
	public void registerPotions(RegistryEvent.Register<Potion> event) {
		event.getRegistry().registerAll(potions.stream().map(Supplier::get).toArray(Potion[]::new));
	}

	@SubscribeEvent
	public void registerSounds(RegistryEvent.Register<net.minecraft.util.SoundEvent> event) {
	}

	@SubscribeEvent
	@SideOnly(Side.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		elements.forEach(element -> element.registerModels(event));
	}

	@EventHandler
	public void preInit(FMLPreInitializationEvent event) {
		MinecraftForge.EVENT_BUS.register(this);
		GameRegistry.registerFuelHandler(this);
		GameRegistry.registerWorldGenerator(this, 5);
		NetworkRegistry.INSTANCE.registerGuiHandler(this, new GuiHandler());
		elements.forEach(element -> element.preInit(event));
		proxy.preInit(event);
	}

	@EventHandler
	public void init(FMLInitializationEvent event) {
		elements.forEach(element -> element.init(event));
		proxy.init(event);
	}

	@EventHandler
	public void serverLoad(FMLServerStartingEvent event) {
		elements.forEach(element -> element.serverLoad(event));
	}

	public static class GuiHandler implements IGuiHandler {

		@Override
		public Object getServerGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			return null;
		}

		@Override
		public Object getClientGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			return null;
		}
	}

	public static class ModElement {

		public static underground_expansion instance;

		public ModElement(underground_expansion instance) {
			this.instance = instance;
		}

		public void init(FMLInitializationEvent event) {
		}

		public void preInit(FMLPreInitializationEvent event) {
		}

		public void generateWorld(Random random, int posX, int posZ, World world, int dimID, IChunkGenerator cg, IChunkProvider cp) {
		}

		public void serverLoad(FMLServerStartingEvent event) {
		}

		public void registerModels(ModelRegistryEvent event) {
		}

		public int addFuel(ItemStack fuel) {
			return 0;
		}
	}
}
