package net.mcreator.underground_expansion;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.common.util.EnumHelper;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.client.event.ModelRegistryEvent;

import net.minecraft.item.ItemArmor;
import net.minecraft.item.Item;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;

public class MCreatorRubyArmor extends underground_expansion.ModElement {

	@GameRegistry.ObjectHolder("underground_expansion:rubyarmorhelmet")
	public static final Item helmet = null;
	@GameRegistry.ObjectHolder("underground_expansion:rubyarmorbody")
	public static final Item body = null;
	@GameRegistry.ObjectHolder("underground_expansion:rubyarmorlegs")
	public static final Item legs = null;
	@GameRegistry.ObjectHolder("underground_expansion:rubyarmorboots")
	public static final Item boots = null;

	public MCreatorRubyArmor(underground_expansion instance) {
		super(instance);
		ItemArmor.ArmorMaterial enuma = EnumHelper.addArmorMaterial("RUBYARMOR", "underground_expansion:rubyarmor", 40, new int[]{10, 10, 10, 10},
				50, null, 3.5f);
		instance.items.add(() -> new ItemArmor(enuma, 0, EntityEquipmentSlot.HEAD).setUnlocalizedName("rubyarmorhelmet")
				.setRegistryName("rubyarmorhelmet").setCreativeTab(CreativeTabs.COMBAT));
		instance.items.add(() -> new ItemArmor(enuma, 0, EntityEquipmentSlot.CHEST).setUnlocalizedName("rubyarmorbody")
				.setRegistryName("rubyarmorbody").setCreativeTab(CreativeTabs.COMBAT));
		instance.items.add(() -> new ItemArmor(enuma, 0, EntityEquipmentSlot.LEGS).setUnlocalizedName("rubyarmorlegs")
				.setRegistryName("rubyarmorlegs").setCreativeTab(CreativeTabs.COMBAT));
		instance.items.add(() -> new ItemArmor(enuma, 0, EntityEquipmentSlot.FEET).setUnlocalizedName("rubyarmorboots")
				.setRegistryName("rubyarmorboots").setCreativeTab(CreativeTabs.COMBAT));
	}

	@SideOnly(Side.CLIENT)
	@Override
	public void registerModels(ModelRegistryEvent event) {
		ModelLoader.setCustomModelResourceLocation(helmet, 0, new ModelResourceLocation("underground_expansion:rubyarmorhelmet", "inventory"));
		ModelLoader.setCustomModelResourceLocation(body, 0, new ModelResourceLocation("underground_expansion:rubyarmorbody", "inventory"));
		ModelLoader.setCustomModelResourceLocation(legs, 0, new ModelResourceLocation("underground_expansion:rubyarmorlegs", "inventory"));
		ModelLoader.setCustomModelResourceLocation(boots, 0, new ModelResourceLocation("underground_expansion:rubyarmorboots", "inventory"));
	}
}
